/**
 * Definitions for the KNX library
 */

export type Encoder = (value: any) => Buffer;
export type Decoder = (buffer: Buffer) => any;

/**
 * @property {string} use
 * @property {string} name
 * @property {string} desc
 * @property {any} enc
 */
export interface DPTSubType {
  use?: string;
  name: string;
  desc: string;
  enc?: any;

  unit?: string;
  range?: number[];
}

/**
 * DPT generic interface
 */
export interface DPT {
  id: string;
  name: string;
  bufferLength: number;
  subtypes: { [index: string]: DPTSubType };

  decoder: Decoder;
  encoder: Encoder;
}